/*
 * test.c
 *
 *  Created on: Jan 20, 2020
 *      Author: sanm
 */

 #include "Fx2.h"
 #include "fx2regs.h"
 #include "FX2LP_I2C.h"

 void FX2LPI2C_Init()  // initializes the I2C interface
 {
 	I2CTL |= bmSTOPIE;
 	EZUSB_InitI2C();
 }

 void FX2LPI2C_XmitChar(BYTE ch) // prints a character
 {
 	BYTE __xdata buf;
 	BYTE length=1;
 	buf = (BYTE __xdata)ch;

 		do
 		{
 			/* Continue to retry till the writes are succesful
 			 * This is to handle cases where the slave does not respond to I2C
 			 * writes.
 			 */
 			EZUSB_WriteI2C(slave_address, length , &buf);
 		}while(!(I2CS & I2C_ACK_MASK));

 }

 void FX2LPI2C_XmitHex2(BYTE b) // prints a byte
  {
  	BYTE __xdata buffer[2];
  	BYTE length=2;

  	buffer[0]=ConvertHEXtoASCII((b >> 4) & 0x0f) ;
  	buffer[1]=ConvertHEXtoASCII(b & 0x0f) ;

  		do
  		{
  			/* Continue to retry till the writes are succesful
  			 * This is to handle cases where the slave does not respond to I2C
  			 * writes.
  			 */
  			EZUSB_WriteI2C(slave_address, length , buffer);
  		}while(!(I2CS & I2C_ACK_MASK));

  }

 void FX2LPI2C_XmitHex4(WORD w) //prints a word
 {
 	BYTE __xdata buffer[4];
 	BYTE b1, b2;
 	BYTE length=4;
 	b1= ((w >> 8) & 0xff) ;
 	b2= w & 0xff ;

 	buffer[0]=ConvertHEXtoASCII((b1 >> 4) & 0x0f) ;
 	buffer[1]=ConvertHEXtoASCII(b1 & 0x0f) ;
 	buffer[2]=ConvertHEXtoASCII((b2 >> 4) & 0x0f) ;
 	buffer[3]=ConvertHEXtoASCII(b2 & 0x0f) ;


 		do
 		{
 			/* Continue to retry till the writes are succesful
 			 * This is to handle cases where the slave does not respond to I2C
 			 * writes.
 			 */
 			EZUSB_WriteI2C(slave_address, length , buffer);
 		}while(!(I2CS & I2C_ACK_MASK));
 }

 void FX2LPI2C_XmitString(BYTE *str) // prints a string
 {
	 	BYTE __xdata *data;
		data = (BYTE __xdata*)str;
 		BYTE length=0;
 		int index=0;

 		while(*(data+index)!='\0') //calculate the length of the string
 		{
 			length++;
 			index++;
 		}

 		do
 		{
 			/* Continue to retry till the writes are succesful
 			 * This is to handle cases where the slave does not respond to I2C
 			 * writes.
 			 */
 			EZUSB_WriteI2C(slave_address, length , data);
 		}while(!(I2CS & I2C_ACK_MASK));

 }

 BYTE ConvertHEXtoASCII(BYTE b) //converts to ASCII character
 {
 	if (b < 10)
 		return (b + '0');
 	else
 		return(b - 10 + 'A');
 }

